<?php
/*
	EDOOG.COM (C) 2006-2014 EDOOG Inc.
	This is NOT a freeware, use is subject to license terms
	V2.5  2013.5.15
*/	

error_reporting(0);

set_time_limit(0);

define('IN_PHPAPP', TRUE);

define('OPENMOBILE', FALSE);

@ob_start("ob_gzhandler");

function PHPAPPSURL(){
		
		$dir=$_SERVER['REQUEST_URI'];
		
		$dirarray=explode('/',$dir);
		
		$dirnum=count($dirarray);
		
		$sdir='';
		
		for($i=0;$i<$dirnum-1;$i++){
			
			if($dirarray[$i]){
				$sdir.='/'.$dirarray[$i];
			}
			
		}
		
		return $sdir;

}

define('SDIR',PHPAPPSURL());    
define('SURL','http://'.$_SERVER ['HTTP_HOST'].SDIR); 

include('phpapp/config.php');

define('PHPAPP_DIR',preg_replace("/\\\/", '/', dirname(__FILE__) ) );

header('Content-type: text/html;charset='.S_CHARSET);

include(Core.'/class/core_class_phpapp.php');

$language='cn';

$phpapp=new SystemConfig();


define('TURL',SDIR.'/phpapp/templates/'.S_TEMPLATE.'/style/blue/');
define('STYLEURL',SURL.'/phpapp/templates/'.S_TEMPLATE.'/style/blue/');
define('STYLESYS',SYS.'/templates/'.S_TEMPLATE.'/style//');

class PHPAPPINSTALL extends PHPAPP{
	
    public $POST,$GET,$errors,$step;
	
	
	function __construct(){	
	
	       parent::__construct();
		   
		   $this->step=empty($_GET['step']) ? 0 : intval($_GET['step']);
	
		   $postkey=array('Submit'=>'','SecurityForm'=>'');
			
		   PHPAPP::$config['templatepath']='html';
		   PHPAPP::$config['stylepath']='blue';
		   PHPAPP::$config['phpappversion']='2.5';
		   
		   $this->POST=$this->POSTArray();
		   
		   foreach($postkey as $key=>$vaule){
			   if(empty($this->POST[$key])){
				   $this->POST[$key]='';
			   }
		   }
		   
		   
		   if($this->step==100){
			     $this->PHPAPPInstallComplete();

		   }elseif($this->step==12){
			     $this->MysqlConnect();
		         $this->PHPAPPInstallInitialize();
		   
		   }elseif($this->step==11){
		         $this->MysqlConnect();
		         $this->PHPAPPInstallCallData();
		   
		   }elseif($this->step==10){
			     $this->MysqlConnect();
		         $this->PHPAPPInstallAdvertising();
		   
		   }elseif($this->step==9){
			     $this->MysqlConnect();
		         $this->PHPAPPInstallTask();
			   
		   }elseif($this->step==8){
			      $this->MysqlConnect();
		          $this->PHPAPPInstallCredit();
		   
		   }elseif($this->step==7){
			      $this->MysqlConnect();
		          $this->PHPAPPInstallConfig();
		   
		   }elseif($this->step==6){
		          $this->MysqlConnect();
				  $this->PHPAPPInstallApps();
				  
		   }elseif($this->step==5){
			      $this->MysqlConnect();
				  $this->PHPAPPInstallCityData();
				
		   }elseif($this->step==4){
			      $this->MysqlConnect();
				  $this->PHPAPPInstallMember();
			   
		   }elseif($this->step==3){
			      $this->MysqlConnect();
				  $this->PHPAPPInstallData();
				  
		   }elseif($this->step==2){
			     $this->MysqlConnect();
				 $this->PHPAPPLoadData();
				 
		   }elseif($this->step==1){
			   
			     $this->PHPAPPConfigData();
			   
		   }else{
			     
				 $this->PHPAPPAuthorize();
			   
		   }
		  
	}
	
	
	function PHPAPPAuthorize(){
		    
		   if($this->POST['Submit']){
			     
				 
				 $allowdirarr=array('attachment','attachment/avatar','attachment/avatar/middle','attachment/avatar/small','attachment/certificate','attachment/upload','phpapp/data','phpapp/apps','phpapp/data/backup','phpapp/data/log','phpapp/data/cache','phpapp/data/make','phpapp/config.php','phpapp/apps/ucclient/uc_client/data/','phpapp/apps/ucclient/uc_client/data/cache','/phpapp/templates/default/html','/phpapp/templates/default/style/blue');
	  
				   $allowdir=preg_replace("/\\\/", '/', dirname(__FILE__).'/');
					
				   $allowdirnum=0;
				   
				  
				   foreach($allowdirarr as $name){
						   
						   if($name=='phpapp/config.php'){
								 
								  if(is_writable($allowdir.$name)){
									   $allowdirnum+=1;
								  }else{
									  
									   $this->errors[]=$name;
								  }
			
						   }else{
								 if($this->WriteFile($allowdir.$name.'/index.html','')){
			
									   $allowdirnum+=1;
								 }else{
									  
									   $this->errors[]=$name;
								 }
						   }
				   
				   }
			
			
				  if(count($allowdirarr)==$allowdirnum){
							
							
						 $this->Refresh('感谢您,支持PHPAPP！',SURL.'/install.php?step=1');
							 
				  }else{
					    
						$errors='';
						
						foreach($this->errors as $value){
							 $errors.='<p>'.$value.'</p>';  
						}
						
						$this->Refresh('<p><strong>对不起！请以下目录为777权限！</strong></p>'.$errors,SURL.'/install.php');
					  
				  }
			  
		  }else{
		
			    include $this->Template('install:authorize');
			  
		  }

	}

		
	function PHPAPPConfigData(){
		   
		   if($this->POST['Submit']){
			   
				 $os=phpversion();
		         $phpv=explode('/',$os);
	
				 if(file_exists(SYS.'/data/install.lock')){
						 echo 1;
						 exit();
				 }
				 
				 if($phpv[0] < 5.2){
					     echo 2;
						 exit();
				 }
				 
				 //$_POST=$this->ConvertArray($_POST);
				 
				 $dbhost=$_POST['dbhost'];
					 
				 $dbuser=$_POST['dbuser'];
				 
				 $dbpw=$_POST['dbpw'];
				 
				 $dbname=$_POST['dbname'];
				 
				 $dbtname=$_POST['dbtname'];
				 
				 $_SESSION['USERNAME']=$_POST['username'];
				 
				 $_SESSION['PASSWORD']=$_POST['password'];
				 
				 $_SESSION['EMAIL']=$_POST['email'];
					 
					 
				 $host=@mysql_pconnect($dbhost,$dbuser,$dbpw);
				 
				 if(!$host){
					   echo 3;
					   exit();
				 }else{
					   
					   $result = mysql_query('show databases;');
					   
					   $mysqldata=array();
					   
					   while($row = mysql_fetch_assoc($result)){       
								$mysqldata[] = $row['Database'];
					   }
					   
					   $isdbname=0;
					   
					   foreach($mysqldata as $dataname){
						     if($dataname==$dbname){
								  $isdbname=1;
							 }
						   
					   }
					   
					   mysql_query('SET names '.DB_CHARSET); 
					   
					   //是否安装过
					   $isinstall=0;
					   if($isdbname){

							  mysql_select_db($dbname,$host);
							  
							  $testtname=$dbtname.'usergroup';
								
							  $result =mysql_fetch_row(mysql_query("SHOW TABLES LIKE '".$testtname."' "));
	
							  if($result[0]){
								   
								    $isinstall=1;
							  }
					   }
					   
					   
					   if($isinstall){
						     echo 4;
					         exit();
					   }else{
						   
					        if(!$isdbname){
								 @mysql_query("CREATE DATABASE $dbname");
								 mysql_select_db($dbname,$host);
							}
										  
							$this->PHPAPPSetConfig(array('SDIR'=>PHPAPPSURL(),'DB_HOST'=>$dbhost,'DB_USER'=>$dbuser,'DB_PW'=>$dbpw,'DB_NAME'=>$dbname,'DB_TNAME'=>$dbtname));
						   
					        echo 'ok';
					        exit();
					   }
				 }
			   
		   }else{

		    	 include $this->Template('install:config');
			
		   }

	}
	
	function PHPAPPShowProgress($value=0,$step=0){
		
		  $showstep='';
		  
		  if($step==100){
		       $showstep='window.parent.window.location.href="'.SURL.'/install.php?step='.$step.'";';
		  }elseif($step>0 && $step<100){
			   $showstep='window.location.href="'.SURL.'/install.php?step='.$step.'";';
		  }
		  
		  return '<script type="text/javascript">window.parent.document.getElementById("InstallProgress").style.width="'.$value.'%";window.parent.document.getElementById("PercentageShow").innerHTML="'.$value.'";'.$showstep.'</script>';
		
	}
	
	function PHPAPPInstallData(){
		        
				 //25.5%
				 
				 $TableFile=SYS.'/install/phpapp.sql';
			     
				 //105 num
				 $TableSql=str_replace('phpapp_',DB_TNAME,$this->GetFile($TableFile));
				 
				 preg_match_all('/DROP TABLE (.*)\;|CREATE TABLE (.*)\;/isU',$TableSql,$TableArray);
				  
				 if($TableArray){
						foreach($TableArray[0] as $key=>$query){
	                           
							  echo $this->PHPAPPShowProgress($key/4);
							   
							  $query=str_replace('ENGINE=MyISAM','ENGINE=MyISAM CHARSET='.DB_CHARSET,$query);
							
							  $this->MysqlQuery($query);
						}
				 }
					   
				 unset($TableArray); 
				 
				 mysql_close();
				 
				 echo $this->PHPAPPShowProgress(26,4);
				 
		  
	}
	
	function InstallDataSql($DataFile=''){
		  
		  $DataSql=str_replace('phpapp_',DB_TNAME,$this->GetFile($DataFile));
										 
		  preg_match_all("/INSERT INTO (.*)\)\;/isU",$DataSql,$DataSqlArray);
	 
		  if($DataSqlArray){
			  foreach($DataSqlArray[0] as $query){
				   $this->MysqlQuery($query);
			  }
		  }
		  
	}
	
	function PHPAPPInstallComplete(){
		  
		  @unlink('index.html');
		  
		  include $this->Template('install:complete');
	}
	
	function PHPAPPInstallInitialize(){
		
		  echo $this->PHPAPPShowProgress(93);
		  
		  $this->SetConfigDIR();
		  
		  $this->UpdateConfig();
		  
		  $this->UpdateApps();
		  $this->UpdateRouteApps();

          $this->GetFileIcon();
		  
		  echo $this->PHPAPPShowProgress(94);
		  
		  $this->UpdateUserLevel();
		  
		  $this->UpdateCreditLevel();
		  
		  echo $this->PHPAPPShowProgress(95);
		  
		  include_once(Core.'/class/category_class_phpapp.php');
		  $category=new CategoryClass();
		  
		  echo $this->PHPAPPShowProgress(96);
		  $category->MakeCategoryCache(1); 
		  
		  echo $this->PHPAPPShowProgress(97);
		  $category->UpdateCategorySubclassID(); 

		  echo $this->PHPAPPShowProgress(98);
		  $category->UpdateWebsiteCategoryCache();
		  
		  echo $this->PHPAPPShowProgress(99);
		  
		  //login
		  $this->WriteFile(SYS.'/data/install.lock','PHPAPP.CN');
		  
		  mysql_close();

		  echo $this->PHPAPPShowProgress(100,100);
	}
	
	function PHPAPPInstallCallData(){
		  echo $this->PHPAPPShowProgress(86);
		  
		  $DataSql=str_replace('phpapp_',DB_TNAME,$this->GetFile(SYS.'/install/calldata.sql'));
		  echo $this->PHPAPPShowProgress(88);
		  $this->MysqlQuery($DataSql);
		  
		  mysql_close();
		  
		  echo $this->PHPAPPShowProgress(90,12);
	}
	
	function PHPAPPInstallAdvertising(){
		  echo $this->PHPAPPShowProgress(75);
		  $this->InstallDataSql(SYS.'/install/advertising.sql');
		  
		  mysql_close();
		  
		  echo $this->PHPAPPShowProgress(80,11);
	}
	
	function PHPAPPInstallTask(){
		  echo $this->PHPAPPShowProgress(68);
		  $this->InstallDataSql(SYS.'/install/task.sql');
		  
		  mysql_close();
		  echo $this->PHPAPPShowProgress(73,10);
	}
	
	function PHPAPPInstallCredit(){
		  echo $this->PHPAPPShowProgress(59);
		  $this->InstallDataSql(SYS.'/install/credit.sql');
		  mysql_close();
		  echo $this->PHPAPPShowProgress(65,9);
	}
	
	
	function PHPAPPInstallConfig(){
		  echo $this->PHPAPPShowProgress(50);
		  $this->InstallDataSql(SYS.'/install/config.sql');
		  mysql_close();
		  echo $this->PHPAPPShowProgress(58,8);
	}
	
	function PHPAPPInstallApps(){
		  echo $this->PHPAPPShowProgress(42);
		  $this->InstallDataSql(SYS.'/install/apps.sql');
		  mysql_close();
		  echo $this->PHPAPPShowProgress(48,7);
	}
	
	function PHPAPPInstallCityData(){
		     echo $this->PHPAPPShowProgress(31);
		     $this->InstallDataSql(SYS.'/install/city.sql');
			 mysql_close();
		     echo $this->PHPAPPShowProgress(40,6);
	}
	
	function PHPAPPInstallMember(){
		     
		     $this->InstallDataSql(SYS.'/install/member.sql');
			 
			 echo $this->PHPAPPShowProgress(28);
				 
			 include_once(APPS.'/member/main_phpapp.php');
			 
			 $this->MysqlQuery("INSERT INTO ".$this->GetTable('member_account')." (`uid`, `money`, `lock`, `wealth`, `credit`, `union`) VALUES(0, '0.00', '0.00', '0.00', 0, '0.00')");
			 
			 $register = new SubmitRegister(array('EMail'=>$_SESSION['EMAIL'],'UserName'=>$_SESSION['USERNAME'],'Password'=>$_SESSION['PASSWORD'],'UserType'=>1));
			 
			 echo $this->PHPAPPShowProgress(29);
			 
			 $uid=$register->InsertRegister(1);
			 
			 if($uid){
				   $this->Update('member',array('admingroup'=>1),array()," WHERE uid='1'");
			 }
		 
			 //30%
			 mysql_close();
			 
			 echo $this->PHPAPPShowProgress(30,5);

	}
	
	function PHPAPPLoadData(){
		   
		   $issession=0;
		   if($_SESSION['USERNAME'] && $_SESSION['PASSWORD'] && $_SESSION['EMAIL']){
			    $issession=1;
		   }
		     
		   include $this->Template('install:install');

	}
	
	
	function PHPAPPSetConfig($definearray){

		   if(!empty($definearray)){
			
				   $config=file_get_contents(SYS.'/config.php');
				   
				   foreach($definearray as $key=>$value){
						 $config=preg_replace("/define\(\'$key\'\,(.*)\)\;/U",'define(\''.$key.'\',\''.$value.'\');',$config);
				   } 
				   
	 
				   $this->WriteFile(SYS.'/config.php',$config);
		   
		   }

    }
	
}


new PHPAPPINSTALL();






?>