<?php
/*
	EDOOG.COM (C) 2009-2012 EDOOG Inc.
	This is NOT a freeware, use is subject to license terms
	V2.0  2012.3.5
*/	

define('IN_PHPAPP', TRUE);

include('phpapp/config.php');

header('Content-type: text/html;charset='.S_CHARSET);

include(Core.'/class/core_class_phpapp.php');

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo S_CHARSET; ?>" />
<title>PHPAPP 2.5 数据库恢复工具</title>
</head>
<?php

$phpapp=new SystemConfig();
         
$phpapp->MemoryCache();

$phpapp->MysqlConnect();

$phpapp->SetConfigDIR();

$phpapp->GetConfig();
	
$phpapp->SetSystemAppKey();

$systemvalue=$phpapp->SetSystemVariable();
		 
$phpapp->SetStylePath();

$phpapp->GetTimezone();

$nowdate=@date("Ymd");

$backupfilearr='';


				  
if(!empty($_POST['Submit'])){
	
		 $backupdate=$_POST['backupdate'];
	
		 $backupdir=$phpapp->ReadSysDir(S_BACKUP_DIR.'/'.$backupdate);
		 $backuplist='';
   
		 foreach($backupdir as $value){
			  
			  $value=$value['filename'];
			  
			  $fileform=$phpapp->GetFileForm($value);
			  
			  if($fileform!='html' && $fileform!='htm'){
				   $value=iconv_substr($value,0,-4,S_CHARSET);
				   $backuparray=explode('_',$value);
				   $backupfilenum=count($backuparray)-1;
				   
				   if(is_numeric($backuparray[$backupfilenum])){
						$newbackupname='';
						for($i=0;$i<$backupfilenum;$i++){
							 if(empty($newbackupname)){
								  $newbackupname.=$backuparray[$i];
							 }else{
								  $newbackupname.='_'.$backuparray[$i];
							 }
						}
			  
						if(empty($backuplist)){
							 $backuplist.=$newbackupname;
						}else{
							 $backuplist.=','.$newbackupname;
						}
				   }else{
						if(empty($backuplist)){
							  $backuplist.=$value;
						}else{
							  $backuplist.=','.$value;
						} 
				   }
			  }
			   
		 }
		 
		 $backuplists=explode(',',$backuplist);
		 
		 $backupfilearr= array_unique($backuplists);
		 
}


if(!empty($_GET['RecoverySubmit']) || !empty($_GET['value'])){
	
		   include_once(Core.'/class/backup_class_phpapp.php');
		   
		   $backup=new BackupSQL();		  
					    
		   if(empty($_GET['value'])){
				 $_GET['value']=1;
		   }
		   
	
		   $backupselect=$_GET['backupselect'];
				
		   $backupdate=$_GET['backupdate'];
		
		  
		   $backupname=S_BACKUP_DIR.'/'.$backupdate.'/'.$backupselect.'_'.$_GET['value'].'.sql';

		   $number=$backup->RestoreData($backupname,$_GET['value'],$backupdate,$backupselect);
	  
}


?>

<?php if(!empty($_GET['RecoverySubmit']) || !empty($_GET['value'])){ ?>

       <?php if($number=='ok'){  ?>
      
       	  <h2 style="color:#F00">恢复完成!为了安全请删除该文件!</h2>
       
       <?php exit(); }else{?>
       
              <p>正在恢复数据<strong><?php echo $_GET['value']; ?></strong>,禁止关闭浏览器或窗口!</p>

              <script type="text/javascript">
			         window.location.href='sqlrestore.php?backupselect=<?php echo $backupselect; ?>&backupdate=<?php echo $backupdate; ?>&value=<?php echo $number; ?>';
			  </script>
              

       <?php } ?>
       
       
<?php exit(); } ?>

<style type="text/css">
/*form*/
.form_input_text{
	line-height: 24px;
	height: 24px;
	padding-left: 4px;
	border-top-width: 1px;
	border-right-width: 1px;
	border-bottom-width: 1px;
	border-left-width: 1px;
	border-top-style: solid;
	border-right-style: solid;
	border-bottom-style: solid;
	border-left-style: solid;
	border-top-color: #999;
	border-right-color: #CCC;
	border-bottom-color: #CCC;
	border-left-color: #999;
}
.form_textarea{
	height: 100px;
	border-top-width: 1px;
	border-right-width: 1px;
	border-bottom-width: 1px;
	border-left-width: 1px;
	border-top-style: solid;
	border-right-style: solid;
	border-bottom-style: solid;
	border-left-style: solid;
	border-top-color: #999;
	border-right-color: #CCC;
	border-bottom-color: #CCC;
	border-left-color: #999;
	margin-top: 4px;
	margin-bottom: 4px;
	padding: 2px;
}
.form_editor{
	line-height: 24px;
	padding-left: 4px;
	border-top-width: 1px;
	border-right-width: 1px;
	border-bottom-width: 1px;
	border-left-width: 1px;
	border-top-style: solid;
	border-right-style: solid;
	border-bottom-style: solid;
	border-left-style: solid;
	border-top-color: #999;
	border-right-color: #CCC;
	border-bottom-color: #CCC;
	border-left-color: #999;
}
.form_input_label{
	width: 120px;
	display: block;
	float: left;
	text-align: right;
	line-height: 24px;
}
.form_input_width_100{width: 100px;}
.form_input_width_150{width: 150px;}
.form_input_width_200{width: 200px;}
.form_input_width_300{width: 300px;}
.form_input_width_400{width: 400px;}
.form_button{
	font-size:12px;
	cursor: hand;
	color: #FFF;
	padding-right: 12px;
	padding-left: 12px;
	background-color: #F60;
	-moz-border-radius: 8px;
	-webkit-border-radius: 8px;
	border-radius: 8px;
	border: 1px solid #999;
	line-height: 26px;
	height: 26px;
	overflow: hidden;
}

.ajax_page{
	text-align: right;
	padding-top: 20px;
	padding-right: 10px;
}
.ajax_page a,.ajax_page span{
	overflow: hidden;
	color:#000;
	text-decoration:none;
	border:1px solid #CCC;
	padding-top: 2px;
	padding-bottom: 2px;
	padding-right: 5px;
	padding-left: 5px;
	-moz-border-radius: 4px;
	-webkit-border-radius: 4px;
	border-radius: 4px;
	background-color: #F6F6F6;
}
.ajax_page span{
	margin-right: 6px;
}
.ajax_page strong{
	margin-right:6px;
	border:1px solid #e89954;
	font-weight:bold;
	color:#000;
	background:#ffca7d;
	padding-top: 2px;
	padding-bottom: 2px;
	padding-right: 5px;
	padding-left: 5px;
    -moz-border-radius: 4px;
	-webkit-border-radius: 4px;
	border-radius: 4px;
}
.ajax_page a:hover{
	text-decoration:none;
	color:#000;
	background:#ffca7d;
	border:1px solid #e89954;
}
.datalist_h2{
	font-weight: bold;
	background-color: #F5F5F5;
}
.datalist tr td{
	height: 30px;
	border-bottom-width: 1px;
	border-bottom-style: solid;
	border-bottom-color: #EBEBEB;
	padding-left: 16px;
}
.datalist tr.over td {
	background-color: #F5F5F5;
}  
.datalist .downorder{
	background-image: url(../images/menu_icon_down.png);
	background-repeat: no-repeat;
	background-position: left 17px;
	display: block;
	line-height: 30px;
}
.datalist .uporder{
	background-image: url(../images/menu_icon_up.png);
	background-repeat: no-repeat;
	background-position: left 17px;
	display: block;
	line-height: 30px;
}
</style>

<body>
<h2>PHPAPP 2.0 数据库恢复工具</h2>

<form action="sqlrestore.php" method="post">
<table width="100%" border="0" cellpadding="0" cellspacing="0" class="datalist">
<tr>
<td>
查找备份日期 <input name="backupdate" type="text" class="form_input_text form_input_width_200" value="<?php if(!empty($backupdate)){ ?><?php echo $backupdate; ?><? }else{ ?><?php echo  $nowdate; }?>"/> 
<input name="Submit" type="Submit" value="搜索" class="form_button"/> 请输入日期 格式：<?php echo  $nowdate; ?> 
</td>
</tr>
</table>
</form>

<?php if($backupfilearr){ ?>
<form action="sqlrestore.php" method="get">
<table width="100%" border="0" cellpadding="0" cellspacing="0" class="datalist">

<tr><td class="list_h2" style="width:300px;">备份文件名</td><td class="list_h2">备份时间</td><td class="list_h2"  style="text-align:left;padding-left:10px;">备份个数</td></tr>
<?php 

$selecnum=0;

foreach ($backupfilearr as $value){
	 
    if($value){
		
        $selecnum+=1;$checkdir=$phpapp->ReadSysDir(S_BACKUP_DIR.'/'.$backupdate);

		$nowbackupfile=$value.'_'.(0).'.sql';
	
		$filetime=@date("Y-m-d H:i:s",filectime(S_BACKUP_DIR.'/'.$backupdate.'/'.$nowbackupfile));
		
		$backupnum=0;
    
		foreach($checkdir as $fileinfo){
		
			 $backupnum+=preg_match("/$value/",$fileinfo['filename'],$arr);
		
		}
		
	    if($selecnum==1){
			  $checked='checked';
	    }else{
			  $checked='';
		}
       
	   if($backupnum==1){
	         $backupnum='单个文件';
	   }
       
	   echo '<tr>
		<td style="width:300px;"><input name="backupselect" id="backupselect" type="radio" value="'.$value.'" '.$checked.' />'.$value.'</td>
		<td style="width:200px;">'.$filetime.'</td>
		<td style="text-align:left;padding-left:10px;">'.$backupnum.'</td>
		</tr>';
    
    }else{
    
         echo '<tr><td colspan="3">该日期下没有备份文件!</td></tr>';

    }
?>

<?php } ?>
    
</table>

<?php if($backupfilearr[0]) ?>
<div class="phpapp_button" style="margin-top:50px;padding-left:30px;"><input type="hidden" name="backupdate" id="backupdate" value="<?php echo  $backupdate; ?>" /> <input name="RecoverySubmit" type="submit" value="提交恢复" class="form_button"/>
</div>
</form>
<?php } ?>



</body>
</html>