<?php
/*
	EDOOG.COM (C) 2009-2012 EDOOG Inc.
	This is NOT a freeware, use is subject to license terms
	V2.0  2012.3.5
*/	

if(!defined('IN_PHPAPP')) {
	exit('Data error');
}

include_once(APPS.'/taskmode/public_phpapp.php');

class SellerServiceMainControls extends TaskPublicClass{
	
    public $POST,$GET,$errors;
	
	public $tid,$sid,$seller,$spaceuid;
	
	function __construct(){	
	
	       
		   parent::__construct();
		   
		   
		   $this->sid=empty($_GET['sid']) ? 0 : intval($_GET['sid']);
		   
		   $this->tid=empty($_GET['tid']) ? 0 : intval($_GET['tid']);
		   
		   $this->seller=empty($_GET['uid']) ? 0 : intval($_GET['uid']);

		   $postkey=array('Submit'=>'','SecurityForm'=>'','edittid'=>'');
			
			
		   $this->POST=$this->POSTArray();
		   
		   $this->GET=$this->GetArray(array('sqlorder','iforder','action','page','total','id','op','mobile','sort','more','tab','did','select'));
		   
		   foreach($postkey as $key=>$vaule){
			   if(empty($this->POST[$key])){
				   $this->POST[$key]='';
			   }
		   }

	}
	
	
	function DefaultAction(){
          if($this->sid>0){
			    $this->ShowAction();
		  }else{
		  		$this->SellerServiceListAction();
		  }
	}
	
	function ShowAction(){
	
			  $service=$this->GetMysqlOne('a.*,b.filepath',"  ".$this->GetTable('task_seller_service')." AS a LEFT JOIN ".$this->GetTable('file')." AS b  ON b.fid=a.logo  WHERE a.status=0  AND a.sid='$this->sid' ");   
			  
			  
			  if($this->uid){
  
					 $allow=$this->CheckAllow('task_seller_usergroup',array(
															  'appallow'=>''
															  )
													   );
					 $errors='';
					 if($allow!='ok' && $allow){ 
					 
							foreach($allow as $value){
								  $errors.='<p>'.$value.'</p>';
							}
							
							$this->Refresh($errors,SURL);
					 }
					 
			  }else{
					
					if(intval(PHPAPP::$config['task_seller_tourist'])){
					
						  $this->Refresh($this->LanguageArray('taskone','Visitors_can_not_view'),SURL.'/index.php?app='.$this->app);
					}
				 
			  }
			  
			  
			  $allow='ok';
			  
			  if($allow=='ok' || $this->IsAdmin()){

					if($service['sid']>0){
				          
						  $this->spaceuid=$service['uid'];
				   
						  include $this->Template('service_show_space');
						 
					}else{
						  $this->Refresh('服务不存在!',SURL.'/index.php?app='.$this->app.'&sid='.$this->sid);
					}
						  
			  }else{ 
	  
					$errors='';
								   
					foreach($allow as $value){
						 $errors.=$value.'<br />';
					}
					
					$this->Refresh($errors,'index.php?app='.$this->app);
			  }
	}

	public function AddProjectAction(){
		   
		   $op=empty($_GET['op']) ? 0 : intval($_GET['op']);
		   
		   $task=$this->GetMysqlOne('*'," ".$this->GetTable('task')." WHERE tid='$this->tid'");
			
		   if($task['tid']>0){
		   
		   
					if($this->IsService($task['serviceuid']) || $task['seller']==$this->uid || $task['uid']==$this->uid || $this->IsAdmin()){
						   
						   if($op==1 && $task['seller']==$this->uid && $task['status']!=1){
							      
								  //生成订单
								  $draft=$this->GetMysqlOne('*'," ".$this->GetTable('task_draft')." WHERE tid='$this->tid' AND uid='$this->uid'");
								  
								  $this->Update('task_draft',array('process'=>1),array(),"WHERE tid='$this->tid' AND uid='$this->uid' ");
													 
								  //检查是否设置过
									if(!$this->IsSQL('task',"WHERE tid='$this->tid' AND draft_success=1")){
											   
												 $this->Update('task',array('draft_success'=>1,'status'=>1),array(),"WHERE  tid='$this->tid'");
												 
		
												 $draft=$this->GetMysqlOne('a.uid,a.did,a.tid,b.subject,c.username'," (".$this->GetTable('task_draft')." AS a LEFT JOIN ".$this->GetTable('task')." AS b ON a.tid=b.tid) LEFT JOIN ".$this->GetTable('member')." AS c ON a.uid=c.uid  WHERE a.tid='$this->tid'");
												  
												 
												 $draftid=$draft['did'];
												 
												 //生成订单-------------------------------------------------------------------------------------
		                                        
												 if(!$this->IsSQL('task_order',"WHERE did='$draftid' AND tid='$this->tid'")){
													 
													   
													   if($this->IsSQL('task',"WHERE tid='$this->tid' AND process>1")){
															 $process=2;
													   }else{
															 $process=1;
													   }
													   

													   $serial=$this->GetOrderNumber();
													   
													   $fee=$this->GetTaskFeeValue('task_seller_usergroup','taskfee',$task['price1'],0,$draft['uid']);
																					   
													   
													   
													   //Create Consume
                                                       //是否托管
													   
													   $order=$this->Insert('task_order',array('buyeruid'=>$task['uid'],'selleruid'=>$draft['uid'],'did'=>$draftid,'tid'=>$this->tid,'money'=>$task['price1']-$fee,'sum'=>$task['price1'],'dateline'=>$this->NowTime()),array());
													  
	
									   
													   $cid=$this->SetConsume(array(
															   'subject'=>$task['subject'], 
															   'appid'=>intval($this->app),
															   'serial'=>$serial,
															   'process'=>$process,
															   'oid'=>$order,
															   'amount'=>$task['price1']-$fee,
															   'fee'=>$fee,
															   'paytype'=>1, //交易类型
															   'payout'=>0,
															   'payin'=>$draft['uid']    //收入者ID
															   
														 ));
													  
													   
													   
												 }
												 
							
												 //生成订单结束----------------------------------------------------------------------------------
												 
												 
											     //单人
												  $autodelivery=intval(PHPAPP::$config['task_auto_delivery']);
												  
												  $closetime=$this->NowTime()+($autodelivery*24*60*60);
												  
												  
												  include_once(Core.'/class/auto_class_phpapp.php');
	
												  $auto=new AUTO();
												  
												  $runid=$auto->SetAutoRun(array(
														'app'=>49,
														'runtime'=>$closetime,
														'function'=>'CloseOrder',
														'oid'=>$order,
														'cid'=>$cid,
														'did'=>$draftid,
														'tid'=>$this->tid
												  ));
												  
												  $this->Update('task_order',array('closetime'=>$closetime,'workdate'=>$autodelivery,'runid'=>$runid,'cid'=>$cid),array(),"WHERE oid='$order'");
						 
												 
												 
												 //中标通知-------------------------------------------------------------------------------------
												 //雇主
												  require_once(APPS.'/apppay/class/process_class_phpapp.php');
												  $send_op='';
												  
												  $send_subject='服务商已同意您服务要求!';
												  $send_content='<p>尊敬的雇主,服务商已同意您的服务要求,等您支付担保金.</p><p style="margin-bottom: 8px;"><a href="'.SURL.'/index.php?app='.$this->app.'&action=4&tid='.$this->tid.'" target="_blank"><span class="show_details">[查看详细]</span></a> <a href="'.SURL.'/member.php?app=48&action=4&oid='.$order.'" target="_blank"><span class="show_details">[查看订单]</span></a></p>';
												  
												  $getprocess=new TaskProcess();
												  $send_op='<p>'.$getprocess->GetBuyerProcessMenu('task_order_credit',$cid).'</p>';
												  
												  $this->Port(array(
																											
																 //SMS
																 'receive_uid'=>$task['uid'], //接收人
													
														
																  //SMS
																  'sms_subject'=>$send_subject,
																  'sms_content'=>$send_content.$send_op,
																  'sms_cid'=>$cid,
																				
																  //EMail
																  'email_title'=>$send_subject,
																  'email_content'=>$send_content,
										
																  //Mobile
																  'mobile_content'=>$send_subject
															
																		  
												  ),3);
											
											     
												 //威客
                                                 $send_op='';
														   
											     $send_subject=$draft['username'].'您的'.$draftid.'号雇用服务订单已生成!';
											   
											     $send_content='<a href="'.SURL.'/member.php?app=48&action=2&oid='.$order.'" target="_blank"><span class="show_details">[查看订单]</span></a>';

												 
												  $this->Port(array(
													  
														 'login_uid'=>$this->uid,
														
														  //Credit
														  'credit_uid'=>$this->uid,
														  
														  'receive_uid'=>$draft['uid'], //接收人
														  
														  //SMS
														  'sms_subject'=>$send_subject,
														  'sms_content'=>$send_content,
														  'sms_cid'=>$cid,
																		
														  //EMail
														  'email_title'=>$send_subject,
														  'email_content'=>$send_content,
								
														  //Mobile
														  'mobile_content'=>$send_subject 													  	  
																					
												  ),3);
												  
												 
												 //中标通知结束-------------------------------------------------------------------------------------
												 
	
												  echo '操作成功,等待雇主支付托管赏金！<br />';
								 
								                  echo $this->CloseNowWindows('#loading',1);
												 
					
								   }else{
										 
										 echo '对不起！您的已经同意过了！<br />';
										 echo $this->CloseNowWindows('#loading');

								   }
		
								 
							   
						   }elseif($op==3 && $task['seller']==$this->uid && $task['status']!=1){
							   
							         if($task['status']>0){
										   
											echo '<p>您已经设置过了!</p>';
										  
									  }else{
											
											$agree=intval($this->GET['agree']);
											
											if(!$agree){
												 $agree=2;
											}
											
											
											$disagree=$this->str($this->POST['disagree'],100,1,0,1,0,1);
			
											$this->Update('task',array('status'=>$agree,'disagree'=>$disagree),array()," WHERE seller='$this->uid' AND tid='$this->tid'");
											
											$draftcontent=$this->str($this->POST['draft'],200,0,0,1,0,1);
											
											$this->Update('task_draft',array('content'=>$draftcontent),array()," WHERE uid='$this->uid' AND tid='$this->tid'");
											
								
											$send_subject='服务商不同意您服务要求!';
											
											if($disagree){
												   $disagree='拒绝信息如下：</p><p>'.$disagree;
											}else{
												   $disagree='</p><p>服务商未填写拒绝信息！';
											}
											
											$send_content='<p>尊敬的雇主,服务商不同意您的服务要求！'.$disagree.'</p><p><a href="'.SURL.'/index.php?app='.$this->app.'&action=4&tid='.$this->tid.'" target="_blank"><span class="show_details">[查看详细]</span></a></p>';
			
											
											
											$this->Port(array(
																							
												 //SMS
												 'receive_uid'=>$task['uid'], //接收人
									
										
												  //SMS
												  'sms_subject'=>$send_subject,
												  'sms_content'=>$send_content,
																
												  //EMail
												  'email_title'=>$send_subject,
												  'email_content'=>$send_content,
						
												  //Mobile
												  'mobile_content'=>$send_subject
											
														  
										   ),3);
											
										  
								       	  echo '<p>操作成功!</p>';
								
									  }
									   
									 echo $this->CloseNowWindows('#loading',1);
						   
							   
						   }else{
						   
								   include_once(Core.'/class/skill_class_phpapp.php');
								   $skilldata=new SkillClass();
								   
								   $nowdate=@date("Y,m,d,H,i,s");
								   $taskendtime=@date('Y,m,d,H,i,s',$task['endtime']);  	
								   
								   $draft=$this->GetMysqlOne('*'," ".$this->GetTable('task_draft')." WHERE tid='$this->tid'");
								   
								   $order=$this->GetMysqlOne('*'," ".$this->GetTable('task_order')." WHERE tid='$this->tid'");
								   
								   
								   $buyersinfo=$this->GetMysqlOne('c.*,d.certificate,d.selltotal,f.credit,f.hao,f.zhong,f.cha,g.speed,g.attitude,g.quality,h.residelatitude,h.residelongitude 	,h.residemapzoom,h.about,d.residecity'," ((((".$this->GetTable('member')." AS c  LEFT JOIN ".$this->GetTable('member_info')." AS d ON c.uid=d.uid)LEFT JOIN ".$this->GetTable('member_account')." AS e ON c.uid=e.uid) LEFT JOIN ".$this->GetTable('credit_score')." AS g ON c.uid=g.uid) LEFT JOIN ".$this->GetTable('member_personal')." AS h ON c.uid=h.uid ) LEFT JOIN ( SELECT credit,uid,hao,zhong,cha FROM ".$this->GetTable('credit')." WHERE type=2 ) AS f ON c.uid=f.uid WHERE c.uid='$task[uid]' AND c.userpost=1 ");
								   
								   $sellerinfo=$this->GetMysqlOne('c.*,d.certificate,d.selltotal,f.credit,f.hao,f.zhong,f.cha,g.speed,g.attitude,g.quality,h.residelatitude,h.residelongitude 	,h.residemapzoom,h.about,d.residecity'," ((((".$this->GetTable('member')." AS c  LEFT JOIN ".$this->GetTable('member_info')." AS d ON c.uid=d.uid)LEFT JOIN ".$this->GetTable('member_account')." AS e ON c.uid=e.uid) LEFT JOIN ".$this->GetTable('credit_score')." AS g ON c.uid=g.uid) LEFT JOIN ".$this->GetTable('member_personal')." AS h ON c.uid=h.uid ) LEFT JOIN ( SELECT credit,uid,hao,zhong,cha FROM ".$this->GetTable('credit')." WHERE type=1 ) AS f ON c.uid=f.uid WHERE c.uid='$task[seller]' AND c.userpost=2 ");
								   
								   //过期 (目前手动申请退款)
								   /*
								   if($this->NowTime()>=($task['dateline']+$task['time']*24*60*60)){
								   
										   include_once(APPS.'/taskmode/public_phpapp.php');
										   $TaskPublic=new TaskPublicClass();
										   $TaskPublic->TaskExpired($this->tid);
								   }
								   */
		 
								   include $this->Template('show');
						   }
					}else{
						  
						  $this->Refresh('您未登录或没有权限查看!',SURL);
						
					}
			
			}else{
				  
				  $this->Refresh('任务不存在!',SURL);
				
			}
		 
	}
	
	function AddDataAction(){
		
		   $tid=intval($this->GET['tid']);
		   $this->seller=$this->spaceuid=intval($this->GET['uid']);

		   $task=$this->GetMysqlOne('*'," ".$this->GetTable('task')." WHERE tid='$tid' AND uid='$this->uid'");
		   
		   $allow=$this->CheckAllow('task_seller_usergroup',array(
															'buyservice'=>'',
															'realnametask'=>''
															)
		   											 );
		   
		  if($allow!='ok'){
				  $errors='';
								 
				  foreach($allow as $value){
					   $errors.=$value.'<br />';
				  }
				  
				  $this->Refresh($errors,'index.php?app='.$this->app);
				  exit();
		  }
	
		  if($this->tid>0){
				
				$task=$this->GetMysqlOne('*'," ".$this->GetTable('task')." WHERE tid='$this->tid' AND uid='$this->uid' ");
				$this->seller=$task['seller'];
				if($task['tid']>0){
					  
					  if($task['process']>3 || $task['status']==1){
						    
							 $this->Refresh('对不起,当前状态不能修改!',SURL.'/index.php?app='.$this->app.'&action=4&tid='.$this->tid);
						    
					  }
					  					   
				}
		  
		  }

		  if($this->sid>0){
		        $service=$this->GetMysqlOne('*'," ".$this->GetTable('task_seller_service')." WHERE sid='$this->sid'");
				
				if($service['realnametask']==1){
					 
					     if(!$this->IsRealName()){
							  
							  $errors='<p>对不起,服务要求实名购买!<p>';
							  
							  if($this->IsWap()){
								  
								   $this->Refresh($errors,'index.php?app='.$this->app.'&action=1');
							  }else{
								   $this->Refresh($errors,'index.php?app='.$this->app.'&action=1');
							  }
							  exit();
						 }
					  
					   
				 }
				 
		  }else{
			    $service='';
		  }


		  if($this->seller>0){
			   
			   if($this->seller == $this->uid){
				   
				       $this->Refresh('对不起,不能雇用自己!','index.php?app='.$this->app.'&action=1');
					   
			   }else{
			  
	
					 $seller=$this->GetMysqlOne('a.username,b.*',"  ".$this->GetTable('member')." AS a LEFT JOIN ".$this->GetTable('member_info')." AS b ON a.uid=b.uid WHERE a.uid='$this->seller' ");          
				 

					 if($seller['uid']>0){
						  
							  $memberinfo=$this->GetMysqlOne('mobile'," ".$this->GetTable('member_info')." WHERE uid='$this->uid' ");
                     
							  if($this->POST['Submit']){
								            
						
									  //if($this->CheckSecurityForm($this->POST['SecurityForm'])){
											  //权限
																											
					  	
											   $allow=$this->CheckAllow('task_seller_usergroup',array(
																					  'addtask'=>'',
																					  'realnametask'=>'',
																					  'addnumbertask'=>'',
																					  'maxmoneytask'=>floatval($this->POST['money']), //发布任务最大托管金额
																					  'smallmoneytask'=>floatval($this->POST['money']) //发布任务最低托管金额
																					  )
																		   );
			
											   
											   if($allow=='ok'){
								
													   $fieldnum=count($this->GetTableFieldArray('task'));
								  
								                       if($this->CheckTask()==(4+$fieldnum)){
	                                                        
															$this->POST['subject']=$this->str($this->POST['subject'],60,0,1,1,0,1);
															
														    $description=$this->str($this->POST['content'],200,0,1,1,0,1);
															if(strlen($this->POST['content'])>200){
																 $description.='...';
															}
															
																	
														   if($this->sid>0 || $this->seller>0 && !$this->tid){
	  
															    $this->tid=$this->Insert('task',array('appid'=>82,'sid'=>$this->sid,'process'=>1,'price1'=>$this->POST['money'],'price2'=>$this->POST['money'],'subject'=>$this->POST['subject'],'content'=>$this->POST['content'],'time'=>$this->POST['time'],'uid'=>$this->uid,'seller'=>$this->seller,'dateline'=>$this->NowTime(),'description'=>$description),array());
																
																
															    $this->Insert('task_draft',array('appid'=>82,'tid'=>$this->tid,'time'=>$this->POST['time'],'uid'=>$this->seller,'price'=>$this->POST['money'],array(),'dateline'=>$this->NowTime()));
																
																
																$this->Update('task',array('url'=>'/index.php?app=82&action=4&tid='.$this->tid),array()," WHERE tid='$this->tid' AND uid='$this->uid'");                                              
																
																
																$send_subject=$this->username.'购买您的服务啦！';
																$send_content='雇主已购买您的服务!等待您的确认 <a href="'.SURL.'/index.php?app='.$this->app.'&action=4&tid='.$this->tid.'" target="_blank"><span class="show_details">[查看详细]</span></a>';
																
																$this->Port(array(
																				
																	   //SMS
																	  'receive_uid'=>$this->seller, //收件人
																
																	
																	  //SMS
																	  'sms_subject'=>$send_subject,
																	  'sms_content'=>$send_content,
																					
																	  //EMail
																	  'email_title'=>$send_subject,
																	  'email_content'=>$send_content,
											
																	  //Mobile
																	  'mobile_content'=>$send_subject
																
																			  
										                       ),2);
																
																
																
																
														   }elseif(!$this->sid && $this->tid>0){
															  
																  $this->Update('task',array('process'=>1,'price1'=>$this->POST['money'],'price2'=>$this->POST['money'],'subject'=>$this->POST['subject'],'content'=>$this->POST['content'],'time'=>$this->POST['time'],'dateline'=>$this->NowTime(),'description'=>$description,'status'=>0),array()," WHERE tid='$this->tid' AND uid='$this->uid'");
																  
																  $this->Update('task_draft',array('price'=>$this->POST['money'],'time'=>$this->POST['time']),array()," WHERE tid='$this->tid' AND uid='$this->seller'");
																  
																  $send_subject=$this->username.'修改了雇用服务！';
																  $send_content='雇主已修改雇用服务!等待您的确认 <a href="'.SURL.'/index.php?app='.$this->app.'&action=4&tid='.$this->tid.'" target="_blank"><span class="show_details">[查看详细]</span></a>';
																	
																  $this->Port(array(
																					
																		   //SMS
																		  'receive_uid'=>$this->seller, //收件人
																	
																		
																		  //SMS
																		  'sms_subject'=>$send_subject,
																		  'sms_content'=>$send_content,
																						
																		  //EMail
																		  'email_title'=>$send_subject,
																		  'email_content'=>$send_content,
												
																		  //Mobile
																		  'mobile_content'=>$send_subject
																	
																				  
																   ),2);
														   
														   }
														   
 

														   if($allow=='ok'){
									   
																	   //上传文件
																	   $files=$this->UploadFile();
																	   
																	   if($files){
																			 foreach($files as $fid){
																				  $this->Insert('apps_file',array('appid'=>$this->app,'fid'=>$fid,'uid'=>$this->uid,'id'=>$this->tid,'type'=>2),array());
																			 }
																			 
																			 $this->ReplaceFileContent($files,'task',$this->POST['content']," WHERE tid='$this->tid' ");
																	   }
																	   
															}else{
																
																  $this->ShowAllowError($allow,"index.php?app=$this->app&action=2&tid=$this->tid");
																
															}
														   
														   
														    $this->Refresh('发布成功,等待卖家确认',SURL.'/index.php?app='.$this->app.'&action=4&tid='.$this->tid);

					   
													   }else{
															 
															 $errors='';
															 
															 if($this->errors){
																	foreach($this->errors as $value){
																		 $errors.='<p>'.$value.'</p>';
																	}
															 }
															 
															 $this->Refresh($errors,'index.php?app='.$this->app.'&action=1');
													   }
											   }else{
												   
													 $errors='';
													 
													 foreach($allow as $value){
														   $errors.=$value.'<br />';
													 }
													 
													 $this->Refresh($errors,'index.php?app='.$this->app.'&action=1');
											   }
									   
									    /*
										}else{
											
											  $this->Refresh('提交表单已过期!','index.php?app='.$this->app.'&action=1');
										}
				                        */
													  
								  
								  
							  }else{
	  
									include $this->AppsView('add');
							  }
							 
					 
					 }else{
						 
							 $this->Refresh('请选择雇用卖家!!','index.php?app='.$this->app.'&action=1');
					 }
					 
			   
			   }
			  
		  }else{
			    $this->Refresh('请选择雇用卖家!','index.php?app='.$this->app.'&action=1');
		  }
		   
		   
		   
	}
	
	
	
	function CheckTask(){
		
		        $checknum=0;

		        //过虑
				foreach($this->POST as $key=>$value){
					   
					   switch($key){
					          case 'subject':
							  
							       $strings=new CharFilter($this->POST['subject']);
								   
								   if(empty($this->POST['subject'])){
							             $this->errors[]='请输入标题!';
								   /*
								   }elseif($strings->CheckSpace()){
							             $this->errors[]='对不起！,标题含有非法代码!';	 
										 */
								   }elseif($strings->CheckLength(5)){  //输入任务标题最小长度 单位 "位"
										 $this->errors[]='对不起！,标题不能少5个字!';
								   }elseif($strings->CheckShort(200)){ //输入任务标题最大长度 单位 "位"
										 $this->errors[]='对不起！,标题太长了!';
								   }else{
									     $checknum+=1;
								   }
		
					          break;
							  case 'money':
							       if(empty($this->POST['money'])){
							             $this->errors[]='请输入赏金!';
									
								   }elseif($this->POST['money']<1){
										  $this->errors[]='赏金不能为0元!';
							       }else{
									     $this->POST['money']=floatval($this->POST['money']);
									     $checknum+=1;
								   }
					          break;
							  case 'time':
							  
							       if(empty($this->POST['time'])){
							             $this->errors[]='请输入任务时间!';
								   }elseif($this->POST['time']<1){
									     $this->errors[]='任务时间不能为0!';
								   }else{
									     $checknum+=1;
								   }
					          break;
							  
							  case 'content':
									$strings=new CharFilter($this->POST['content']);
									if(empty($this->POST['content'])){
										 $this->errors[]='请输入内容!';
									}elseif($strings->CheckLength(5)){  //输入任务内容最小长度 单位 "位"
										 $this->errors[]='对不起！,内容不能少5个字!';
									}else{
									     $checknum+=1;
								    }
							  break;
							  
							  
					   }
				}	
				
				
				//自定义字段---------------------------------------------------

			   $fieldresult=$this->GetTableFieldResult('task',$this->POST);
			   
               if($fieldresult['checknum']){
				   
					 $checknum+=$fieldresult['checknum'];
					 
					 if($fieldresult['errors']){
						  foreach($fieldresult['errors'] as $value){
								$this->errors[]=$value;
						  }
					 }
					 
					 $this->POST=$fieldresult['post'];
			   
			   }
			   
			   //自定义字段 end---------------------------------------------------
		
		       return $checknum;
	}
	
	
	
	
	
	function SellerServiceListAction($catid=0,$skill=0,$app=0){
		   
		   if($app==82){
		   		$this->app=$app;
		   }
		   
		   include_once(Core.'/class/skill_class_phpapp.php');
		   
		   $skilldata=new SkillClass();
		
           $selectarray=array(
	
					  array('name'=>'默认排序','data'=>array('默认排序','报价从高到低','报价从低到高','完成时间从少到多','完成时间从多到少','出售量从少到多','出售量从多到少'),'id'=>'sort'),	
					  array('name'=>'筛选模式','data'=>array('0'=>'0','1'=>'1'),'id'=>'select'),
					  array('name'=>'显示更多','data'=>array('0'=>'0','1'=>'1'),'id'=>'more'),
					  array('name'=>'列表切换','data'=>array('0'=>'0','1'=>'1'),'id'=>'tab')
			     );
   
   
		   require_once(Core.'/class/list_class_phpapp.php');
		   
		   $selectclass=new SelectData($selectarray,$catid,$skill);

		   $selectitem=$selectclass->GetSelectOne('task_seller_select');

           $selectctarray=$selectclass->GetSelectCategory();

		   $selectsql=$selectclass->GetSelectOneSQL($selectitem[2],$selectctarray[5],'a.catid','d.residecity','c.skills');
		   
		    include_once(Core.'/class/pages_class_phpapp.php');
				

			 //排序
			 switch ($this->GET['sort']) {
					 case '1':
					 $order=' a.price DESC';
					 break;
					 case '2':
					 $order=' a.price ASC';
					 break;
					 case '3':
					 $order=' a.time ASC';
					 break;
					 case '4':
					 $order=' a.time DESC';
					 break;
					 case '5':
					 $order=' a.sellnum ASC';
					 break;
					 case '6':
					 $order=' a.sellnum DESC';
					 break;
					 default:
					 $order=' a.topbid DESC , a.sellnum DESC ';
			}
						

				
				   $pageurl=$selectclass->GetSelectAllURL();
				   
			       $page=new Pages(16,$this->GET['page'],$pageurl,"SELECT a.*,c.username,c.dateline AS regtime,c.logintime,d.certificate,d.residecity,f.credit,g.speed,g.attitude,g.quality,h.thumb,h.thumbcut FROM (((((".$this->GetTable('task_seller_service')." AS a LEFT JOIN ".$this->GetTable('member')." AS c ON a.uid=c.uid) LEFT JOIN ".$this->GetTable('member_info')." AS d ON c.uid=d.uid)LEFT JOIN ".$this->GetTable('member_account')." AS e ON c.uid=e.uid) LEFT JOIN ".$this->GetTable('credit_score')." AS g ON c.uid=g.uid) LEFT JOIN ( SELECT credit,uid FROM ".$this->GetTable('credit')." WHERE type=1 ) AS f ON c.uid=f.uid ) LEFT JOIN ".$this->GetTable('file')." AS h  ON h.fid=a.logo WHERE a.status=0 $selectsql GROUP BY a.sid  ORDER BY $order ");
				   
			 
			       $list=$page->ShowResult();

				   //SEO
				   PHPAPP::$SEO['title']=empty($selectctarray[2])? '' :$selectctarray[2];
				   PHPAPP::$SEO['keywords']=empty($selectctarray[3])? '' :$selectctarray[3];
				   PHPAPP::$SEO['description']=empty($selectctarray[4])? '' :$selectctarray[4];
				   
				   include $this->AppsView('sellerservice:list');
		
	}
	
	
	function GetServiceURL($sid,$uid=0,$app=0){
		  if(!$uid){
			   $uid=$this->uid;
		  }
		  
		  if(!$app){
			  $app=$this->app;
		  }
		  
		  include_once(Core.'/class/makeurl_class_phpapp.php');
		  
		  $make=new MakeTaskAddressUrl();
		  
		  return $make->GetServiceAddress($sid,$uid,$app,$string);
		  
	}
}




?>